var alertram = 90;
var alertswap = 90;
var alertdisk = 90;


function deleteSerial(serial) {
    var tr = $("tr[data-serial='" + serial + "']");
    var connected = ($(tr).attr("data-connected") === "true");
    if (connected) {
        if (!confirm("Attention, cet IPBX est actuellement connecté. Etes vous sur de vouloir le supprimer ?"))
            return;
    }
    $(tr).remove();
    $.get("main.php?action=del&serial=" + serial, () => {

    });
}

function UpdateConnexion()
{
    $.getJSON("main.php?action=connected", function (data)
    {
        var ports = data;
        $("[data-type='ipbx']").each(function (index)
        {
            var tr = this;
            var port1 = $(tr).attr('data-port1');
            var port2 = $(tr).attr('data-port2');
            if (ports.indexOf(port1) > -1 || ports.indexOf(port2) > -1)
            {
                $(tr).find('.connectstatus').attr('src', 'img/connected.png' );
                $(tr).attr('data-connected', true);
            }
            else
            {
                $(tr).find('.connectstatus').attr('src', 'img/disconnected.png' );
                $(tr).attr('data-connected', false);
            }
        });
        filtrer();
    });
}



async function hasStatsAsync(serial) {
    return new Promise((resolve) => {
        $.getJSON("main.php?action=hasstats&serial=" + serial, (data) =>
        {
            resolve(data);
        });
    });
}

async function GetLastStatsAsync(serial) {
    return new Promise((resolve) => {
        $.getJSON("main.php?action=laststats&serial=" + serial, (data) =>
        {
            resolve(data);
        });
    });
}



async function UpdateHasStatsAsync()
{
    //pour toutes les lignes qui n'ont pas de stats seulement
    try {
        var trs = $("[data-has-stats='false']");
        for (var tr of trs) {
            var serial = $(tr).attr('data-serial');
            var hasstats = await hasStatsAsync(serial);
            if (hasstats) {
                var stats = await GetLastStatsAsync(serial);
                $(tr).attr('data-has-stats', true);
                $(tr).find('.td-stats').html("<a href='' data-toggle='modal' data-target='#modalstats' onclick='displayLastStatsAsync(\"" + serial + "\")'><i class='glyphicon glyphicon-stats'></i> voir</a>");
                
                var totalram = stats.totalram / 1024;
                var usedram = (stats.totalram - stats.availableram)/1024;
                var usedrampercent = (stats.totalram - stats.availableram) * 100 / stats.totalram;
                var totalswap = stats.swaptotal / 1024;
                var usedwap = (stats.swaptotal - stats.swapfree)/1024;
                var usedswappercent = (stats.swaptotal - stats.swapfree) * 100 / stats.swaptotal;
                var totaldisk = parseInt(stats.totaldisk);
                var freedisk = parseInt(stats.freedisk);
                var useddisk = totaldisk-freedisk;
                var useddiskpercent = ((useddisk * 100) / totaldisk).toFixed(2);
                
                var alert = false;
                if (usedrampercent > alertram)
                    alert=true;
                if (usedswappercent > alertswap)
                    alert=true;
                if (useddiskpercent > alertdisk)
                    alert=true;
                
                if (alert) {
                    $(tr).find('.td-alarm').html("<i class='glyphicon glyphicon-warning-sign'></i>");
                    $(tr).attr('data-has-alarm', true);
                }
                else {
                    $(tr).find('.td-alarm').html("");
                    $(tr).attr('data-has-alarm', false);
                }
            }
        } 
    }
    catch (e) {}
    
    var afficherAlarmes = $("#checkbox-afficher-alarmes").prop("checked");
    if (afficherAlarmes) {
        $("[data-has-alarm='true']").show();
    }
}


async function displayLastStatsAsync(serial) {
    console.log("Loading stats for " + serial);
    $(".title-loading-stats").show();
    $(".stats-nostats").hide();
    $("#div-stats").hide();
    $(".stat-value").html('');
    var stats = await GetLastStatsAsync(serial);
    if (stats !== null ) {
        var totalram = stats.totalram / 1024;
        var usedram = (stats.totalram - stats.availableram)/1024;
        var usedrampercent = (stats.totalram - stats.availableram) * 100 / stats.totalram;
        var totalswap = stats.swaptotal / 1024;
        var usedwap = (stats.swaptotal - stats.swapfree)/1024;
        var usedswappercent = (stats.swaptotal - stats.swapfree) * 100 / stats.swaptotal;
        var momdate = moment.unix(stats.date);
        var totalpeers = parseInt(stats.peersoffline) + parseInt(stats.peersonline);
        var diffdate = moment().diff(momdate, 'seconds');
        var totaldisk = parseInt(stats.totaldisk);
        var freedisk = parseInt(stats.freedisk);
        var useddisk = totaldisk-freedisk;
        var useddiskpercent = ((useddisk * 100) / totaldisk).toFixed(2);

        $(".stat-date").html(momdate.format("L LTS") + " - " + momdate.fromNow());
        if (diffdate > 120) {
            $(".stat-date").css('color', 'red');
        }
        else {
            $(".stat-date").css('color', '');
        }
        $(".stat-serial").html(stats.serial);

        $(".stat-version").html(stats.version);

        $(".stat-memoire").html(usedram.toFixed(0) + " MB / " + totalram.toFixed(0) + " MB (" + usedrampercent.toFixed(2) + "%)");
        if (usedrampercent > alertram)
            $(".stat-memoire").addClass('text-danger');
        else 
            $(".stat-memoire").removeClass('text-danger');

        $(".stat-swap").html(usedwap.toFixed(0) + " MB / " + totalswap.toFixed(0) + " (" + usedswappercent.toFixed(2) + "%)");
        if (usedswappercent > alertswap)
            $(".stat-swap").addClass('text-danger');
        else 
            $(".stat-swap").removeClass('text-danger');

        $(".stat-disk").html(useddisk + " MB / " + totaldisk + " (" + useddiskpercent + "%)");
        if (useddiskpercent > alertdisk)
            $(".stat-disk").addClass('text-danger');
        else 
            $(".stat-disk").removeClass('text-danger');

        $(".stat-loadavg").html(stats.loadavg1);

        $(".stat-calls").html(stats.calls + " appels en cours");

        $(".stat-peers").html(stats.peersonline + " connectés / " + totalpeers + " total");

        $(".stat-trunks").html(stats.registered + " trunks enregistrés");

        $("#div-stats").show();
    }
    else {
        $(".stats-nostats").show();
    }
    $(".title-loading-stats").hide();
    timerstats = setTimeout(() => {
        getLastStats(serial);
    }, 60000);
}

function isFiltered(tr)
{   
    var s = $('#inputfiltre').val().toUpperCase();
    if (s === "")
    {
        return false;
    }
    else
    {
        if ($(tr).attr('data-nom').toUpperCase().indexOf(s) === -1
             && $(tr).attr('data-serial').toUpperCase().indexOf(s) === -1
             && $(tr).attr('data-port1').toUpperCase().indexOf(s) === -1
             && $(tr).attr('data-port2').toUpperCase().indexOf(s) === -1) //rien ne correspond
        {
            return true; //le résultat est donc filtré puisque rien ne correspond
        }
        else
        {
            return false;
        }
    }
}

function filtrer()
{
    var afficherDecos = $("#checkbox-afficher-deconnectes").prop("checked");
    var afficherAlarmes = $("#checkbox-afficher-alarmes").prop("checked");
    $("[data-type='ipbx']").each(function (index)
    {
        if (isFiltered($(this)))
        {
            $(this).hide();
        }
        else
        {
            var connected = ($(this).attr("data-connected") === "true");
            var alarme = ($(this).attr("data-has-alarm") === "true");
            if (!connected) {
                if (afficherDecos) {
                    $(this).show();
                }
                else {
                    $(this).hide();
                }
            }
            else {
                $(this).show();
            }
            
            if (afficherAlarmes && !alarme) {
                $(this).hide();
            }
        }
    });
}var alertram=90,alertswap=90,alertdisk=90;function deleteSerial(t){var a=$("tr[data-serial='"+t+"']");"true"===$(a).attr("data-connected")&&!confirm("Attention, cet IPBX est actuellement connecté. Etes vous sur de vouloir le supprimer ?")||($(a).remove(),$.get("main.php?action=del&serial="+t,()=>{}))}function UpdateConnexion(){$.getJSON("main.php?action=connected",function(t){var a=t;$("[data-type='ipbx']").each(function(t){var e=this,s=$(e).attr("data-port1"),r=$(e).attr("data-port2");a.indexOf(s)>-1||a.indexOf(r)>-1?($(e).find(".connectstatus").attr("src","img/connected.png"),$(e).attr("data-connected",!0)):($(e).find(".connectstatus").attr("src","img/disconnected.png"),$(e).attr("data-connected",!1))}),filtrer()})}async function hasStatsAsync(t){return new Promise(a=>{$.getJSON("main.php?action=hasstats&serial="+t,t=>{a(t)})})}async function GetLastStatsAsync(t){return new Promise(a=>{$.getJSON("main.php?action=laststats&serial="+t,t=>{a(t)})})}async function UpdateHasStatsAsync(){try{var t=$("[data-has-stats='false']");for(var a of t){var e=$(a).attr("data-serial");if(await hasStatsAsync(e)){var s=await GetLastStatsAsync(e);$(a).attr("data-has-stats",!0),$(a).find(".td-stats").html("<a href='' data-toggle='modal' data-target='#modalstats' onclick='displayLastStatsAsync(\""+e+"\")'><i class='glyphicon glyphicon-stats'></i> voir</a>");s.totalram,s.totalram,s.availableram;var r=100*(s.totalram-s.availableram)/s.totalram,i=(s.swaptotal,s.swaptotal,s.swapfree,100*(s.swaptotal-s.swapfree)/s.swaptotal),n=parseInt(s.totaldisk),o=(100*(n-parseInt(s.freedisk))/n).toFixed(2),l=!1;r>alertram&&(l=!0),i>alertswap&&(l=!0),o>alertdisk&&(l=!0),l?($(a).find(".td-alarm").html("<i class='glyphicon glyphicon-warning-sign'></i>"),$(a).attr("data-has-alarm",!0)):($(a).find(".td-alarm").html(""),$(a).attr("data-has-alarm",!1))}}}catch(t){}$("#checkbox-afficher-alarmes").prop("checked")&&$("[data-has-alarm='true']").show()}async function displayLastStatsAsync(t){console.log("Loading stats for "+t),$(".title-loading-stats").show(),$(".stats-nostats").hide(),$("#div-stats").hide(),$(".stat-value").html("");var a=await GetLastStatsAsync(t);if(null!==a){var e=a.totalram/1024,s=(a.totalram-a.availableram)/1024,r=100*(a.totalram-a.availableram)/a.totalram,i=a.swaptotal/1024,n=(a.swaptotal-a.swapfree)/1024,o=100*(a.swaptotal-a.swapfree)/a.swaptotal,l=moment.unix(a.date),d=parseInt(a.peersoffline)+parseInt(a.peersonline),c=moment().diff(l,"seconds"),p=parseInt(a.totaldisk),m=p-parseInt(a.freedisk),h=(100*m/p).toFixed(2);$(".stat-date").html(l.format("L LTS")+" - "+l.fromNow()),c>120?$(".stat-date").css("color","red"):$(".stat-date").css("color",""),$(".stat-serial").html(a.serial),$(".stat-version").html(a.version),$(".stat-memoire").html(s.toFixed(0)+" MB / "+e.toFixed(0)+" MB ("+r.toFixed(2)+"%)"),r>alertram?$(".stat-memoire").addClass("text-danger"):$(".stat-memoire").removeClass("text-danger"),$(".stat-swap").html(n.toFixed(0)+" MB / "+i.toFixed(0)+" ("+o.toFixed(2)+"%)"),o>alertswap?$(".stat-swap").addClass("text-danger"):$(".stat-swap").removeClass("text-danger"),$(".stat-disk").html(m+" MB / "+p+" ("+h+"%)"),h>alertdisk?$(".stat-disk").addClass("text-danger"):$(".stat-disk").removeClass("text-danger"),$(".stat-loadavg").html(a.loadavg1),$(".stat-calls").html(a.calls+" appels en cours"),$(".stat-peers").html(a.peersonline+" connectés / "+d+" total"),$(".stat-trunks").html(a.registered+" trunks enregistrés"),$("#div-stats").show()}else $(".stats-nostats").show();$(".title-loading-stats").hide(),timerstats=setTimeout(()=>{getLastStats(t)},6e4)}function isFiltered(t){var a=$("#inputfiltre").val().toUpperCase();return""!==a&&(-1===$(t).attr("data-nom").toUpperCase().indexOf(a)&&-1===$(t).attr("data-serial").toUpperCase().indexOf(a)&&-1===$(t).attr("data-port1").toUpperCase().indexOf(a)&&-1===$(t).attr("data-port2").toUpperCase().indexOf(a))}function filtrer(){var t=$("#checkbox-afficher-deconnectes").prop("checked"),a=$("#checkbox-afficher-alarmes").prop("checked");$("[data-type='ipbx']").each(function(e){if(isFiltered($(this)))$(this).hide();else{var s="true"===$(this).attr("data-connected"),r="true"===$(this).attr("data-has-alarm");s?$(this).show():t?$(this).show():$(this).hide(),a&&!r&&$(this).hide()}})}
